package com.compomics.scripts_marc;

import com.compomics.util.experiment.biology.Peptide;
import static com.compomics.util.experiment.identification.IdentificationMatch.MatchType.Peptide;
import com.compomics.util.experiment.identification.identification_parameters.IdentificationAlgorithmParameter;
import com.compomics.util.experiment.identification.identification_parameters.SearchParameters;
import com.compomics.util.io.json.JsonMarshaller;
import com.compomics.util.io.json.marshallers.IdentificationParametersMarshaller;
import com.compomics.util.preferences.IdentificationParameters;
import com.compomics.util.preferences.MarshallableParameter;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;

/**
 *
 * @author Marc Vaudel
 */
public class JsonTest {


    public static void main(String[] args) {

        JsonTest m = new JsonTest();

        try {
            m.viaString();
            m.write();
            m.read();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    private void viaString() {
        
        Class objectType = SearchParameters.class;
        SearchParameters parameters = new SearchParameters();
        IdentificationParametersMarshaller instance = new IdentificationParametersMarshaller();
        //1. Marshall to JSON
        String parametersAsJson = instance.toJson(parameters);
        //System.out.println(parametersAsJson);
        //2. Unmarshall back to a parameters object
        SearchParameters jsonAsParameters = (SearchParameters) instance.fromJson(objectType, parametersAsJson);
        //System.out.println(jsonAsParameters);
        //3. Compare both
        MarshallableParameter.Type type = jsonAsParameters.getType();
    }
    
    private void write() throws IOException, FileNotFoundException, ClassNotFoundException {
        
        File testFile = new File("C:\\Users\\mva037\\Desktop\\test\\PS_CLI.par");
        
        SearchParameters searchParameters = new SearchParameters();
        IdentificationParameters identificationParameters = new IdentificationParameters(searchParameters);
        identificationParameters.setType();
        
        IdentificationParameters.saveIdentificationParameters(identificationParameters, testFile);
    }
    
    private void read() throws IOException, ClassNotFoundException {
        
        File testFile = new File("C:\\Users\\mva037\\Desktop\\test\\PS_CLI.par");
        
        IdentificationParameters identificationParameters = IdentificationParameters.getIdentificationParameters(testFile);
    }
    
    private class TestClass implements Serializable, MarshallableParameter {
        
    /**
     * Name of the type of marshalled parameter.
     */
    private String marshallableParameterType = Type.identification_parameters.name();
        private double double1 = 180;
        private Double double2 = 180.0;
        private int int1 = 180;
        private boolean boolean1 = true;
        private boolean boolean2 = false;
        private String string = "string1";
        private ArrayList<String> list;
        
        public TestClass() {
            list = new ArrayList<String>(1);
            list.add("string2");
        }

    @Override
    public Type getType() {
        if (marshallableParameterType == null) {
            return null;
        }
        return Type.valueOf(marshallableParameterType);
    }

        @Override
        public void setType() {
            // do nothing
        }
    }
}
